;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
; modchip8a (Advanced) nuevo codigo por cortesia de USB. Agradecimientos a Manolo y compaia por el ASM original              
;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

;--------------------------------------------------------------------------

;                   ͻ
;                    ESQUEMA DE CONEXIONES PIC12C509A 
;                   ͼ
;
;                            ͻ  ͻ
;                                  ͼ      
;                       +5V ̹1  PIC12C508A  8̹ MASA
;                               PIC12C508A   
;                     SWAPX ̹2 GPIO5  GPIO0 7̹ DVDIN=0                      
;                                            
;                  DVDOUT=1 ̹3 GPIO4  GPIO1 6̹ TXSCEE    
;                                            
;                  /RESET=0 ̹4 GPIO3  GPIO2 5̹ SWAPY     
;                                            
;                            ͼ
;           
; 1 - +5VCC  - SIN COMENTARIOS
; 2 - SWAPX  - SOLO LO USA LA OPCION 3 PARA LA APERTURA Y CIERRE DEL DVD
; 3 - DVDOUT - ES IGUAL A 1 CUANDO LA BANDEJA DEL DVD ESTA SALIENDO
; 4 - /RESET - ES IGUAL A 0 CUANDO PULSAMOS EL RESET DE LA PS2
; 5 - SWAPY  - SOLO LO USA LA OPCION 3 PARA LA APERTURA Y CIERRE DEL DVD
; 6 - TXSCEE - ES POR DONDE TRANSMITE VIA SERIE "SCEE"
; 7 - DVDIN  - ES IGUAL A 0 CUANDO LA BANDEJA DEL DVD ESTA ENTRANDO
; 8 - MASA   - SIN COMENTARIOS
;--------------------------------------------------------------------------

;ͻ
; PROCESADOR A EMPLEAR PIC12C508A 
;ͼ
P509A EQU 0          ;0=PIC12C508A 1=PIC12C509A
 IF        P509A
 list      p=12c509A
 include   "p12c509A.inc"
 ELSE
 list      p=12c508A
 include   "p12c508A.inc"
 ENDIF

;ͻ
; FUSIBLES, WASDOG, OSCILADOR ETC.. 
;ͼ
 __FUSES _MCLRE_OFF & _CP_OFF & _WDT_OFF & _IntRC_OSC

;ͻ
; NOTACION DECIMAL 
;ͼ
 radix   dec
;--------------------------------------------------------------------------

;ͻ
; VARIABLES DE RAM INTERNA 
;ͼ
 cblock 0x0B
        RAM_0B  ;CONTADOR PAUSA
   ; no usado     RAM_0C  ;INDICADOR DE MODO USB (a cero) o modo 8modchip
        RAM_0D  ;CONTADOR PAUSA
        RAM_0E  ;CANTIDAD DE BYTES A ENVIAR DE LA TABLA
        RAM_0F  ;CANTIDAD DE BITS A ENVIAR DEL BYTE
        RAM_10  ;NO UTILIZADA
        RAM_11  ;CONTADOR W EN PAUSA Wx199
        RAM_12  ;CONTADOR 199 EN PAUSA Wx199
        RAM_13  ;BYTE LEIDO DE LA TABLA
        RAM_14  ;PUNTERO DEL BYTE DE LA TABLA
        RAM_15  ;MASCARA ESTADO DE LOS BIT DEL PUERTO
        RAM_16  ;CONTADOR DE TABLA (scei,scea,scee)
   ; no usado     RAM_17  ; ESTADO DE BANDEJA 0-DENTRO 1-FUERA
     
 endc
;--------------------------------------------------------------------------

;ͻ
; VECTOR DE RESET 
;ͼ
;	org	0xc0 ; direccion de comienzo del patch
        org	0x0
        movwf   OSCCAL          ;CALIBRA EL OSCILADOR INTERNO
        goto    COMIENZO        ;SALTA LA COMIENZO DEL PROGRAMA

;--------------------------------------------------------------------------

;ͻ
; VERSION DEL PROGRAMA (CODIGO INUTIL) 
;ͼ
        retlw   'U'
        retlw   'S'
        retlw   'B'
        retlw   ' '
        retlw   'M'
        retlw   'O'
        retlw   'D'
        retlw   '8'
        retlw   'A'
        

        ;--------------------------------------------------------------------------
ENVIASCEE2
          goto ENVIASCEE
BANDEJA2
          goto BANDEJA

TABLA   addwf   PCL,F           ;TABLA PARA LA PS2 ASIA,AMERICA,EUROPA
        retlw   'S'
        retlw   'C'
        retlw   'E'
        retlw   'I'
        retlw   'S'
        retlw   'C'
        retlw   'E'
        retlw   'A'
        retlw   'S'
        retlw   'C'
        retlw   'E'
        retlw   'E'

;ͻ
; PAUSA DE 50 MILISEGUNDOS 
;ͼ

PAUSA50MSG
        movlw   50              
;ͻ
; PAUSA DE (W x 1 MILISEGUNDO) 
;ͼ
PAUSAWX1MSG
        movwf   RAM_11          
ETI_042 movlw   199             
        movwf   RAM_12          
ETI_044 nop                     
        clrwdt                  
        decfsz  RAM_12,F        
        goto    ETI_044         
        nop                     
        decfsz  RAM_11,F        
        goto    ETI_042         
        retlw   3               
;--------------------------------------------------------------------------

;ͻ
; COMIENZO DEL PROGRAMA 
;ͼ
COMIENZO
        movlw   b'11000010'     ;CONFIGURA TMR0 PRESCALER = 1:8
        option                  ;OSCILADOR = 4MHZ

        movlw   255             ;INICIALIZA TODOS LOS PUERTOS
        movwf   RAM_15          ;EN ALTO Y RAM_15
	tris	GPIO		;
;--------------------------------------------------------------------------

;ͻ
; PAUSA DE ENCENDIDO DE 414 MILISEGUNDOS 
;ͼ
        

        movlw   2               ;100 MILISEGUNDOS
        movwf   RAM_0D          ;
ETI_107 call    PAUSA50MSG      ;       +
        decfsz  RAM_0D,F        ;
        goto    ETI_107         ;
        movlw   6               ;300 MILISEGUNDOS
        movwf   RAM_0D          ;
ETI_10C call    PAUSA50MSG      ;       +
        decfsz  RAM_0D,F        ;
        goto    ETI_10C         ;
        movlw   14              ;14 MILISEGUNDOS
        call    PAUSAWX1MSG     ;
;--------------------------------------------------------------------------

;ͻ
; LECTURA DE LAS 3 OPCIONES CON EL PULSADOR DE RESET DE LA CONSOLA 
;ͼ
;OPCION1 EL RESET NO HA SIDO PULSADO
;-----------------------------------
        btfsc   GPIO,3          ;SI EL RESET NO ESTA PULSADO
        goto    OPCION1         ;SALTA A OPCION1

;OPCION2 EL RESET HA SIDO PULSADO Y SE HA SOLTADO ANTES DE 7,5 SEGUNDOS
;----------------------------------------------------------------------
        movlw   150             ;
        movwf   RAM_0D          ;
ETI_115 btfsc   GPIO,3          ; 
        goto    OPCION2         ;SALTA A OPCION2 AL LEVANTAR EL RESET
        call    PAUSA50MSG      ;
        decfsz  RAM_0D,F        ;
        goto    ETI_115         ;

;OPCION3 EL RESET HA SIDO PULSADO Y NO SE HA SOLTADO ANTES DE 7,5 SEGUNDOS
;-------------------------------------------------------------------------
        goto    OPCION3         ;SI CONTINUA PULSADO SALTA A OPCION3
;--------------------------------------------------------------------------


;ͻ
; OPCION 1 (RESET NO PULSADO) EL MODCHIP SE         
; DESHABILITA Y SOLO PODEMOS USAR JUEGOS ORIGINALES 
;ͼ
OPCION1
        movlw   b'00111111'     ;INICIALIZA TODOS LOS
        tris    GPIO            ;PUERTOS EN ALTO Y
        btfsc   GPIO,3          ;SI EL RESET NO ESTA PULSADO
        goto    OPCION1         ;SALTA A OPCION1 (en espera)
;OPCION EN SEGUNDO RESET.  MODO ESPECIAL XTREME+EA
; EN ESTE MODO DESPUES DE ESPERAR 35 SEGUNDOS, SE EXPULSA LA BANDEJA AUTOMATICAMENTE. SI ANTES DE LA EXPULSION
; O DESPUES CUANDO SE RECOJA LA BANDEJA, SE HACE EXPULSION MANUAL, SE ACTIVA OPCION 2

;///////////////////////////////////////////
;//           METODO EA ESPECIAL          //
;///////////////////////////////////////////

OPCION4  
; ESPERA 35 SEGUNDOS Y HAZ MODO EA     
        movlw   250               ;12,5 segundos
        movwf   RAM_0D          ;
UNO    
        call    PAUSA50MSG      ; 
        btfss   GPIO,3          ;SI EL RESET  ESTA PULSADO
        goto    OPCION4         ;SALTA A OPCION4 (modo especial)
        btfsc   GPIO,4          ;ESPERA A QUE PULSEMOS LA APERTURA
        goto    OPCION2         ;PARA PASAR A MODO CHIP PSX
    
        decfsz  RAM_0D,F        ;
        goto    UNO         ;
     
         
        movlw   250               ;12,5 segundos
        movwf   RAM_0D          ;
DOS 
        call    PAUSA50MSG      ;   
        btfss   GPIO,3          ;SI EL RESET  ESTA PULSADO
        goto    OPCION4         ;SALTA A OPCION4 (modo especial)
        btfsc   GPIO,4          ;ESPERA A QUE PULSEMOS LA APERTURA
        goto    OPCION2         ;PARA PASAR A MODO CHIP PSX
   
        decfsz  RAM_0D,F        ;
        goto    DOS         ;
          movlw   200               ;10 segundos
        movwf   RAM_0D          ;
TRES 
        call    PAUSA50MSG      ;   
        btfss   GPIO,3          ;SI EL RESET  ESTA PULSADO
        goto    OPCION4         ;SALTA A OPCION4 (modo especial)
        btfsc   GPIO,4          ;ESPERA A QUE PULSEMOS LA APERTURA
        goto    OPCION2         ;PARA PASAR A MODO CHIP PSX
   
        decfsz  RAM_0D,F        ;
        goto    TRES         ;
        
        goto OPCION3           ; METODO EA
    
 

        ;sleep                   ;DESHABILITA EL MODCHIP, pero ya no se usa
;--------------------------------------------------------------------------

;ͻ
; OPCION 2 (RESET PULSADO DESPUES DE 1 SEG. Y SOLTADO ANTES DE 7,5 SEG.) 
; JUEGOS (PSX1 DIRECTOS) Y (PSX2 SIN PROTECCION ANTIMODCHIP CON AR1.3)   
;ͼ

; LA OPCION20 ES LA OPCION2, CON PAUSA
OPCION20
        movlw   2               ;100 MILISEGUNDOS
        movwf   RAM_0D          ;
ETI_807 call    PAUSA50MSG      ;       +
        decfsz  RAM_0D,F        ;
        goto    ETI_807         ;
        movlw   6               ;300 MILISEGUNDOS
        movwf   RAM_0D          ;
ETI_80C call    PAUSA50MSG      ;       +
        decfsz  RAM_0D,F        ;
        goto    ETI_80C         ;
        movlw   14              ;14 MILISEGUNDOS
        call    PAUSAWX1MSG     ;
 

;la opcion2 esta modificada ahora para que se comporte como chip de PSX 7502
OPCION2
        bcf     GPIO,1          ;INICIALIZA PUERTO TXSERIE EN ALTO
        bcf     RAM_15,1        ;
        movf    RAM_15,W        ;
	tris	GPIO
        call    PAUSA50MSG      ; una pequea pausa
        		

ETI_122
       
        clrf    RAM_14          ;INICIALIZA PUNTERO A TABLA Y
        call    ENVIASCEE2       ;TRANSMITE VIA SERIE HASTA EL INFINITO 'SCEE'
        call BANDEJA2;  
        btfss   GPIO,3          ;SI EL RESET  ESTA PULSADO
        goto    OPCION20         ;SALTA A OPCION20

        goto    ETI_122       
;--------------------------------------------------------------------------

;ͻ
; OPCION 3 (RESET PULSADO DESPUES DE 1 SEG. Y SOLTADO DESPUES DE 7,5 SEG.) 
; JUEGOS PSX2 CON PROTECCION ANTIMODCHIP CON AR1.3                         
;ͼ
OPCION3
        btfss   GPIO,3          ;ESPERA A QUE SOLTEMOS EL
        goto    OPCION3         ;BOTON DE RESET
        
        movlw   255             ;INICIALIZA RAM_15 Y TODOS
        movwf   RAM_15          ;LOS PUERTOS
        tris    GPIO            ;EN ALTO

        movlw   80              ;EL MODCHIP FUERZA A LA CONSOLA
        movwf   RAM_0B          ;PARA QUE EXPULSE LA BANDEJA DEL DVD
ETI_132 movlw   b'00100100'     ;                 "
        movwf   GPIO            ;                 "
        movlw   b'11011011'     ;                 "
        tris    GPIO            ;                 "
        movlw   10              ;                 "
        call    PAUSAWX1MSG     ;                 "
        movlw   b'00100000'     ;                 "
        movwf   GPIO            ;                 "
        movlw   b'00011011'     ;                 "
        tris    GPIO            ;                 "
        movlw   10              ;                 "
        call    PAUSAWX1MSG     ;                 "
        decfsz  RAM_0B,F        ;                 "
        goto    ETI_132         ;                 "
        movlw   b'00111111'     ;                 "
        tris    GPIO            ;                 "

        movlw   32              ;PAUSA PARA QUE LA BANDEJA DEL DVD 
        movwf   RAM_0B          ;ESTE 8 SEGUNDOS ABIERTA Y NOS DE 
ETI_144 
        btfss   GPIO,3          ;SALTA OPCION 4 SI SE PULSA
        goto    OPCION4         ;BOTON DE RESET

        movlw   250             ;TIEMPO A PONER EL JUEGO EN ELLA
        btfss   GPIO,3          ;SI EL RESET  ESTA PULSADO
        goto    OPCION4         ;SALTA A OPCION4 (modo especial)
        call    PAUSAWX1MSG     ;                 "
        decfsz  RAM_0B,F        ;                 "
        goto    ETI_144         ;                 "

        movlw   80              ;EL MODCHIP FUERZA A LA CONSOLA
        movwf   RAM_0B          ;PARA QUE INTRODUZCA LA BANDEJA DEL DVD
ETI_14A movlw   b'00010100'     ;                 "
        movwf   GPIO            ;                 "
        movlw   b'11101011'     ;                 "
        tris    GPIO            ;                 "
        movlw   10              ;                 "
        call    PAUSAWX1MSG     ;                 "
        movlw   b'00010000'     ;                 "
        movwf   GPIO            ;                 "
        movlw   b'11101011'     ;                 "
        tris    GPIO            ;                 "
        movlw   10              ;                 "
        call    PAUSAWX1MSG     ;                 "
        decfsz  RAM_0B,F        ;                 "
        goto    ETI_14A         ;                 "
        movlw   b'00111111'     ;                 "
        tris    GPIO            ;                 "
;/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
;// OPCION QUE HABILITA EL CHIP (MODO PSX) SI ES LO QUE QUEREMOS (NO HACE NADA HASTA QUE PULSAMOS RESET O EXPULSAR BANDEJA) //
;/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
ETI_500
        btfss   GPIO,3          ;SALTA OPCION 4 SI SE PULSA
        goto    OPCION4         ;BOTON DE RESET
        btfss   GPIO,4          ;ESPERA A QUE PULSEMOS LA APERTURA
        goto    ETI_500         ;DE LA BANDEJA DEL DVD O RESET 
        goto    OPCION2         ;PARA PASAR A MODO CHIP PSX
;--------------------------------------------------------------------------
BANDEJA
        btfss   GPIO,4          ;ESPERA A QUE PULSEMOS LA APERTURA
        retlw 1
        
ETI_058
        btfss   GPIO,3          ;SI EL RESET  ESTA PULSADO
        retlw 1
        btfsc   GPIO,4          ;SI LA BANDEJA DEL DVD ESTA ABRIENDOSE
        goto    ETI_058         ;SE ASEGURA A QUE SE ABRA DEL TODO

CIERRA  
        movlw   120              ;codigo redundante sin efecto
        movwf   RAM_0B          ; codigo redundante sin efecto
ETI_05C 
        retlw 1




;ͻ
; TRANSMITE VIA SERIE LA LICENCIA ('SCEE') CON 8 BIT DE DATOS Y 2 DE STOP A 250 BPS 
;ͼ
ENVIASCEE
        movwf   RAM_0D          ;SALVA W EN RAM_0D (INUTIL PUES NO LO USA)

          movlw 3 
          movwf RAM_16               ;INICIA NUM ELEM DE TABLA A TRANSMITIR

LICENCIA    movlw   72              ;72 MILISEGUNDOS DE ESPACIO ENTRE BYTES
        call    PAUSAWX1MSG     ;

        movlw   4               ;ENVIAREMOS 4 BYTES
        movwf   RAM_0E          ;DE LA TABLA
ETI_068
        movf    RAM_14,W        ;LEEMOS 1 BYTE DE
        call    TABLA           ;LA TABLA
        movwf   RAM_13          ;EN RAM_13
        comf    RAM_13,F        ;

        movlw   8               ;ENVIAREMOS 8
        movwf   RAM_0F          ;BITS DE CADA BYTE

        bsf     RAM_15,1        ;ENVIA EL BIT DE START VIA SERIE
        movf    RAM_15,W        ;
	tris	GPIO		;

        movlw   4               ;4 MILISEGUNDOS DEL ANCHO DEL BIT DE START
        call    PAUSAWX1MSG     ;

ETI_073
        rrf     RAM_13,F        ;ENVIA 1 BIT DEL BYTE VIA SERIE
        movlw   b'11111000'     ;
	movwf	GPIO		;
        btfsc   STATUS,0        ;
        bsf     RAM_15,1        ;
        btfss   STATUS,0        ;
        bcf     RAM_15,1        ;
        movf    RAM_15,W        ;
	tris	GPIO		;

        movlw   4               ;4 MILISEGUNDOS DEL ANCHO DEL BIT
        call    PAUSAWX1MSG     ;

        decfsz  RAM_0F,F        ;CONTINUAMOS HASTA
        goto    ETI_073         ;ENVIAR LOS 8 BITS DEL BYTE

        bcf     RAM_15,1        ;ENVIA 2 BITS DE STOP
        movf    RAM_15,W        ;
	tris	GPIO		;

        movlw   8               ;8 MILISEGUNDOS DEL ANCHO DE
        call    PAUSAWX1MSG     ;LOS 2 BITS DE STOP

        incf    RAM_14,F        ;INCREMENTA PUNTERO DE LA TABLA

        decfsz  RAM_0E,F        ;CONTINUA HASTA
        goto    ETI_068         ;ENVIAR LOS 4 BYTES DE LA TABLA
        decfsz  RAM_16,F             ;Do specified number of lines
	  goto    LICENCIA

        retlw   3               ;RETORNA CON W=03H


	end

